=== debian/changelog ===
eigen3 (3.3.4-4) unstable; urgency=medium

  [ Gael Guennebaud ]
  * [8038706] Fix gcc7 warning: Wint-in-bool-context.

  [ Anton Gladky ]
  * [303a17a] Set Standards-Version to 4.1.3
  * [ea5c809] Remove testsuite-field in d/control
  * [5d43f27] Set compat-level 11
  * [8a9f17a] Set priority optional instead of extra

 -- Anton Gladky <gladk@debian.org>  Thu, 08 Feb 2018 21:21:09 +0100

eigen3 (3.3.4-3) unstable; urgency=medium

  * Team upload
  * Fix compilation of Jacobi rotations with ARM NEON (Closes: #868786)
  * Bump Standards-Version to 4.1.0, no changes

 -- Graham Inggs <ginggs@debian.org>  Tue, 19 Sep 2017 05:42:40 +0000

eigen3 (3.3.4-2) unstable; urgency=medium

  * Upload into the unstable.

 -- Anton Gladky <gladk@debian.org>  Fri, 30 Jun 2017 21:28:41 +0200

eigen3 (3.3.4-1) experimental; urgency=medium

  * [5a0ad0a] New upstream version 3.3.4
  * [576d2cd] Refresh patches.
  * [dc9448e] Update upstream changelog.

 -- Anton Gladky <gladk@debian.org>  Thu, 29 Jun 2017 19:10:59 +0200

eigen3 (3.3.3-1~exp1) experimental; urgency=medium

  [ Anton Gladky ]
  * [51a12ed] Update d/watch.
  * [e417e67] New upstream version 3.3.3. (Closes: #860761)
  * [f043732] Refresh patches.
  * [a5e7759] Update upstream changelog.
  * [473dc6e] Switch to compat-level 10.
  * [5b31761] Update d/copyright.

  [ Radovan Birdic ]
  * [ca21efc] Fix mips alignment issue. (Closes: #858363)

 -- Anton Gladky <gladk@debian.org>  Sat, 20 May 2017 10:27:19 +0200
